#include "../route.h"
#include "AtomicPredicate.h"
#include "Predicate.h"
#include "AtomicAction.h"
#include "Action.h"
#include "Clause.h"
#include "Rule.h"
#include "ASPathList.h"
#include "Utils.h"

CASPathList::CASPathList ( int listnumber, bool to_permit, 
						 const std::string & reg_exp )
	:list_number( listnumber )
{
	rule = CRule( );
	CAtomicPredicate elementary_predicate( ASpath::TYPECODE, reg_exp );
	CPredicate predicate; 
	predicate.addAtom( elementary_predicate );
	rule.addClause( CClause( predicate, CAction( to_permit ) ) );
}

CASPathList::~CASPathList(void) {
}

bool 
CASPathList::applyTo ( Route & route ) {
	return rule.applyTo( route );
}

std::string 
CASPathList::toString ( const std::string & input ) {
	std::string str = input + "AS_path list";
	std::string lst_number_str = Utils::converToString( list_number );
	str += lst_number_str + ":\n";
	str += rule.toString();
	return str;
}
