#pragma once

#include <vector>
class CCAtomicAction;
class Route;

/************************************************************************/
/* noor: CAction applies changes to the path of the given route and 
		 permits or denies smth for the given route.					*/
/************************************************************************/

class CAction
{
public:
	CAction ( bool _permit );
	CAction ( bool _permit, const std::vector<CAtomicAction> & _atoms );
	~CAction (void);

	void addAtom ( const CAtomicAction & new_atom );
	bool applyTo ( Route & route );
	std::string toString ( ) { return toString(""); }
	std::string toString ( const std::string & input );
private:
	bool permit;
	std::vector<CAtomicAction> atoms;
};
