#pragma once

class Route;

/************************************************************************/
/* noor: CAtomicAction - class-helper - changes given path's attribute depending on 
		 action type.													*/
/************************************************************************/

class CAtomicAction
{
public:
	CAtomicAction ( int attrib_val, bool using_nhi, int action_val,
		std::string val );
	~CAtomicAction(void);

	void applyTo ( Route & route );
	std::string toString ( ) { return toString(""); }
	std::string toString ( const std::string & input );

private:
	int attribute_type;
	int action_type;
	std::string value;//std::vector<std::string> - in current version just first value's used; so vector is not needed.
	bool use_NHI;

private:
	static const int SET     = 0;
	/** Indicates an action which prepends a value. */
	static const int PREPEND = 1;
	/** Indicates an action which appends a value. */
	static const int APPEND  = 2;
	/** The maximum value of any action constant. */
	static const int MAX_ACTION_VALUE = 2;

	/** The names, in string form, of each action type. */
	static const std::string ACTION_NAMES [];

};
