#include "../route.h"
#include <string>
#include "AtomicAction.h"
#include "Action.h"
#include "AtomicPredicate.h"
#include "Predicate.h"
#include "Clause.h"


CClause::CClause( CPredicate _predicate, CAction _action )
	:action( _action ),
	predicate( _predicate ) {
}

CClause::~CClause(void)
{
}

bool * 
CClause::applyTo( Route & route ) {
	bool * results  = new bool[2];
	results[0] = results[1] = false; 
	if ( predicate.applyTo( route ) ) {
		results[0] = true;
		results[1] = action.applyTo( route );
		return results;
	}
	return results; // the predicate did not match
}

std::string 
CClause::toString( const std::string & input ) {
	std::string str = input + "clause:\n";
	str += predicate.toString(input + "  ");
	str += action.toString(input + "  ");
	return str;
}
