#pragma once

class Route;
class CPredicate;
class CAction;

/************************************************************************/
/* Each instance of this class represents a clause in a BGP policy
   rule.  A clause maps a predicate (on a route) to an action.          */
/************************************************************************/

class CClause
{
public:
	CClause ( CPredicate _predicate, CAction _action );
	~CClause(void);

	bool* applyTo ( Route & route );
	std::string toString ( ) { return toString(""); }
	std::string toString ( const std::string & input );
private:
	CPredicate predicate;
	CAction action;
};
