#include "../route.h"
#include "AtomicPredicate.h"
#include "Predicate.h"

CPredicate::CPredicate(void)
{
}

CPredicate::CPredicate( const std::vector<CAtomicPredicate> & atom_list )
:atoms( atom_list ) {
}

CPredicate::~CPredicate(void)
{
}

bool 
CPredicate::applyTo( Route & route ) {
	if ( atoms.empty() )
		return true;
		
	for ( size_t i = 0; i < atoms.size(); ++i ) {
		if ( !atoms[i].applyTo( route ) )
			return false;
	}

	return true;
}

std::string 
CPredicate::toString( const std::string & input ) {
	std::string str = input + "predicate:\n";
	if ( !atoms.empty() ) {
		for ( size_t i = 0; i < atoms.size(); i++ ) {
			str += atoms[i].toString( input + "  " );
			if ( i != atoms.size() - 1 ) {
				str += " AND";
			}
			str += "\n";
		}
	} else {
		str += input + "  match any route\n";
	}
	return str;
}


