#pragma once

class CAtomicPredicate;
class Route;

/************************************************************************/
/* noor: CPredicate applies list of predicates to appropriate attributes 
		 of the route.
		 applyTo returns true only if all of them match.				*/
/************************************************************************/

class CPredicate
{
public:
	CPredicate (void);
	CPredicate ( const std::vector<CAtomicPredicate> & atom_list );
	~CPredicate (void);

	void addAtom ( const CAtomicPredicate & new_atom ) { atoms.push_back( new_atom ); }
	bool applyTo ( Route & route );
	std::string toString ( ) { return toString(""); }
	std::string toString ( const std::string & input );

private:
	std::vector<CAtomicPredicate> atoms;

};
