#include "../Util/ipaddress.h"
#include "../route.h"
#include "AtomicAction.h"
#include "Action.h"
#include "AtomicPredicate.h"
#include "Predicate.h"
#include "Clause.h"
#include "Rule.h"
#include "PrefixList.h"


CPrefixList::CPrefixList( const std::string & _name, bool _permit, 
						int _prefix, int _length )
	:name( _name )
{
	rule = CRule( );
	IPaddress ipaddress( _prefix, _length );
	CAtomicPredicate atomic_predicate( Route::NLRI, ipaddress.toString() );
	CPredicate predicate;
	predicate.addAtom( atomic_predicate );
	rule.addClause( CClause( predicate, CAction( _permit ) ) );
}

CPrefixList::~CPrefixList(void) {
}

bool 
CPrefixList::applyTo( Route & route )
{
	return rule.applyTo( route );
}

std::string 
CPrefixList::toString( const std::string & input )
{
	std::string str = input + "prefix_list " + name + ":\n";
	str += rule.toString();
	return str;
}
