#pragma once

#include <vector>
#include <string>
#include <map>


class CClause;
class Route;

/************************************************************************/
/* noor: CRule works as a filter in BGP applying given clauses (combination 
		 of action and predicate) to the route. 
		 Depending on list of clauses different policies may be applied 
		 such as peer to peer; sibling-to-sibling etc.					*/
/************************************************************************/

class CRule
{
public:
	CRule ( bool permit = true );
	CRule ( const std::vector<CClause> & clause_list );
	~CRule(void);

	void addClause ( const CClause & clause ) { clauses.push_back( clause ); }
	bool applyTo ( Route & route );
	std::string toString ( );
private:
	std::vector<CClause> clauses;
};
